{
  "openapi": "3.2.0",
  "info": {
    "title": "Orders",
    "description": "An order represents a payment between two or more parties. Use the Orders API to create, update, retrieve, authorize, and capture orders.",
    "version": "2.36"
  },
  "servers": [
    {
      "url": "https://api-m.sandbox.paypal.com",
      "description": "PayPal API Sandbox"
    }
  ],
  "tags": [
    {
      "name": "externalcallback",
      "description": "PayPal will use the callback url defined in the create order request to send merchants shipping address and shipping options data while the buyer is in the PayPal checkout."
    },
    {
      "name": "orders",
      "description": "Use the `/orders` resource to create, update, retrieve, authorize, capture and track orders."
    },
    {
      "name": "trackers",
      "description": "Use the `/trackers` resource to update and retrieve tracking information for PayPal orders."
    },
    {
      "name": "certs",
      "description": "Use the `/certs` resource to retrieve the public certificates needed to verify PayPal callback request signatures."
    }
  ],
  "externalDocs": {
    "url": "../doc/USERGUIDE.md"
  },
  "paths": {
    "/v2/checkout/orders": {
      "post": {
        "operationId": "orders.create",
        "summary": "Create order",
        "description": "Creates an order. Merchants and partners can add Level 2 and 3 data to payments to reduce risk and payment processing costs. For more information about processing payments, see <a href=\"https://developer.paypal.com/docs/checkout/advanced/processing/\">checkout</a> or <a href=\"https://developer.paypal.com/docs/multiparty/checkout/advanced/processing/\">multiparty checkout</a>.<blockquote><strong>Note:</strong> For error handling and troubleshooting, see <a href=\"https://developer.paypal.com/api/rest/reference/orders/v2/errors/#create-order\">Orders v2 errors</a>.</blockquote>",
        "tags": [
          "orders"
        ],
        "security": [
          {
            "Oauth2": [
              "https://uri.paypal.com/services/payments/payment",
              "https://uri.paypal.com/services/payments/orders/deprecating-jssdk-migration-for-limited-merchants"
            ]
          }
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/paypal_request_id"
          },
          {
            "name": "PayPal-Partner-Attribution-Id",
            "description": "PayPal Partner can send a PayPal-Partner-Attribution-Id request header with the value that they have been assigned by the PayPal Partner program. This value is known as a BN Code. In order to reward such partners (through partner programs), all the activities (including API calls) that they are doing on behalf of the merchants need to be tracked.",
            "in": "header",
            "required": false,
            "schema": {
              "type": "string",
              "minLength": 1,
              "maxLength": 36,
              "pattern": "^[\\S\\s]*$"
            }
          },
          {
            "$ref": "#/components/parameters/paypal_client_metadata_id"
          },
          {
            "name": "Prefer",
            "description": "The preferred server response upon successful completion of the request. Value is:<ul><li><code>return=minimal</code>. The server returns a minimal response to optimize communication between the API caller and the server. A minimal response includes the <code>id</code>, <code>status</code> and HATEOAS links.</li><li><code>return=representation</code>. The server returns a complete resource representation, including the current state of the resource.</li></ul>",
            "in": "header",
            "required": false,
            "schema": {
              "type": "string",
              "minLength": 1,
              "maxLength": 25,
              "pattern": "^[a-zA-Z=,-]*$",
              "default": "return=minimal"
            },
            "examples": {
              "samples_orders_create_samples_orders_create_orders_with_shipping_type_pickup_in_store": {
                "summary": "Create Order - Buy Online Pickup In Store Shipping Type",
                "description": "Creates an order with minimal parameters and contains the Buy Online Pickup in Store-related fields.",
                "value": "return=representation"
              },
              "samples_orders_create_create_orders_with_venmo_app_switch_pickup_in_store": {
                "summary": "Create Order - Buy Online Pickup In Store Shipping Type",
                "description": "Creates an order with venmo payment source and contains the Buy Online Pickup in Store-related fields.",
                "value": "return=representation"
              }
            }
          },
          {
            "$ref": "#/components/parameters/authorization"
          },
          {
            "$ref": "#/components/parameters/paypal_auth_assertion"
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/order_request"
              },
              "examples": {
                "samples_orders_create_samples_orders_create_00_orders_create": {
                  "summary": "Create Order - PayPal Wallet as Payment Source, Resulting in PAYER_ACTION_REQUIRED Response",
                  "description": "Creates a new order. API caller receives payer-action link.",
                  "value": {
                    "intent": "CAPTURE",
                    "payment_source": {
                      "paypal": {
                        "experience_context": {
                          "payment_method_preference": "IMMEDIATE_PAYMENT_REQUIRED",
                          "landing_page": "LOGIN",
                          "shipping_preference": "GET_FROM_FILE",
                          "user_action": "PAY_NOW",
                          "return_url": "https://example.com/returnUrl",
                          "cancel_url": "https://example.com/cancelUrl"
                        }
                      }
                    },
                    "purchase_units": [
                      {
                        "invoice_id": "90210",
                        "amount": {
                          "currency_code": "USD",
                          "value": "230.00",
                          "breakdown": {
                            "item_total": {
                              "currency_code": "USD",
                              "value": "220.00"
                            },
                            "shipping": {
                              "currency_code": "USD",
                              "value": "10.00"
                            }
                          }
                        },
                        "items": [
                          {
                            "name": "T-Shirt",
                            "description": "Super Fresh Shirt",
                            "unit_amount": {
                              "currency_code": "USD",
                              "value": "20.00"
                            },
                            "quantity": "1",
                            "category": "PHYSICAL_GOODS",
                            "sku": "sku01",
                            "image_url": "https://example.com/static/images/items/1/tshirt_green.jpg",
                            "url": "https://example.com/url-to-the-item-being-purchased-1",
                            "upc": {
                              "type": "UPC-A",
                              "code": "123456789012"
                            }
                          },
                          {
                            "name": "Shoes",
                            "description": "Running, Size 10.5",
                            "sku": "sku02",
                            "unit_amount": {
                              "currency_code": "USD",
                              "value": "100.00"
                            },
                            "quantity": "2",
                            "category": "PHYSICAL_GOODS",
                            "image_url": "https://example.com/static/images/items/1/shoes_running.jpg",
                            "url": "https://example.com/url-to-the-item-being-purchased-2",
                            "upc": {
                              "type": "UPC-A",
                              "code": "987654321012"
                            }
                          }
                        ]
                      }
                    ]
                  }
                },
                "error_samples_orders_create_error_samples_orders_create_422_unprocessable_entity_missing_pickup_address": {
                  "summary": "Create Order - 422 Unprocessable Entity Error - Missing Pickup Address",
                  "description": "This code sample attempts to create an order but the shipping address is required and `shipping.type` is set to PICKUP_FROM_PERSON ",
                  "value": {
                    "intent": "AUTHORIZE",
                    "payment_source": {
                      "paypal": {
                        "experience_context": {
                          "return_url": "https://www.example.com/returnURL",
                          "cancel_url": "https://www.example.com/cancelURL",
                          "shipping_preference": "SET_PROVIDED_ADDRESS"
                        }
                      }
                    },
                    "purchase_units": [
                      {
                        "reference_id": "PUHF",
                        "amount": {
                          "currency_code": "USD",
                          "value": "100.00"
                        },
                        "shipping": {
                          "type": "PICKUP_FROM_PERSON"
                        }
                      }
                    ]
                  }
                },
                "samples_orders_create_samples_orders_create_authorize_single_step_paypal_with_vault_id_and_stored_credentials_usage_pattern": {
                  "summary": "Create and authorize an order for a PayPal wallet vaulted account holder passing a usage pattern indicator using stored credentials (Single Shot).",
                  "description": "Creates an order and authorizes payment with a PayPal wallet vault id as the payment source and a usage pattern (billing indicator) RECURRING_PREPAID passed using stored credentials.",
                  "value": {
                    "intent": "AUTHORIZE",
                    "purchase_units": [
                      {
                        "amount": {
                          "currency_code": "USD",
                          "value": "100.00"
                        }
                      }
                    ],
                    "payment_source": {
                      "paypal": {
                        "vault_id": "2w915838hr181240m",
                        "stored_credential": {
                          "payment_initiator": "MERCHANT",
                          "usage": "SUBSEQUENT",
                          "usage_pattern": "RECURRING_PREPAID"
                        }
                      }
                    }
                  }
                },
                "samples_orders_create_samples_orders_create_orders_with_shipping_type_pickup_in_store": {
                  "summary": "Create Order - Buy Online Pickup In Store Shipping Type",
                  "description": "Creates an order with minimal parameters and contains the Buy Online Pickup in Store-related fields.",
                  "value": {
                    "intent": "AUTHORIZE",
                    "purchase_units": [
                      {
                        "reference_id": "PUHF",
                        "amount": {
                          "currency_code": "USD",
                          "value": "50.00"
                        },
                        "payee": {
                          "email_address": "merchant@example.com"
                        },
                        "shipping": {
                          "address": {
                            "address_line_1": "123 Townsend St",
                            "address_line_2": "Floor 6",
                            "admin_area_2": "San Francisco",
                            "admin_area_1": "CA",
                            "postal_code": "94107",
                            "country_code": "US"
                          },
                          "type": "PICKUP_IN_STORE"
                        }
                      }
                    ]
                  }
                },
                "samples_orders_create_samples_orders_create_simple": {
                  "summary": "Create Order - Minimal Request and Response",
                  "description": "Creates an order with only required parameters. By default, uses the minimal representation.",
                  "value": {
                    "intent": "CAPTURE",
                    "purchase_units": [
                      {
                        "amount": {
                          "currency_code": "USD",
                          "value": "100.00"
                        }
                      }
                    ]
                  }
                },
                "samples_orders_create_create_orders_with_venmo_app_switch_pickup_in_store": {
                  "summary": "Create Order - Buy Online Pickup In Store Shipping Type",
                  "description": "Creates an order with venmo payment source and contains the Buy Online Pickup in Store-related fields.",
                  "value": {
                    "intent": "AUTHORIZE",
                    "purchase_units": [
                      {
                        "reference_id": "PUHF",
                        "amount": {
                          "currency_code": "USD",
                          "value": "50.00"
                        },
                        "payee": {
                          "email_address": "merchant@example.com"
                        },
                        "shipping": {
                          "address": {
                            "address_line_1": "123 Townsend St",
                            "address_line_2": "Floor 6",
                            "admin_area_2": "San Francisco",
                            "admin_area_1": "CA",
                            "postal_code": "94107",
                            "country_code": "US"
                          },
                          "type": "PICKUP_IN_STORE"
                        }
                      }
                    ]
                  }
                },
                "samples_orders_create_orders_create_authorize_paypal_wallet_app_switch_with_return_cancel_app_url": {
                  "summary": "Create and Authorize an order with PayPal Wallet and App Switch with return, cancel and fallback app URLs",
                  "description": "Creates a new order and authorizes the payment using PayPal wallet with App Switch. Merchant provides separate return_app_url and cancel_app_url for native app redirection, which PayPal uses as-is without appending /success or /cancel.",
                  "value": {
                    "intent": "AUTHORIZE",
                    "purchase_units": [
                      {
                        "reference_id": "d9f80740-38f0-11e8-b467-0ed5f89f718b",
                        "amount": {
                          "currency_code": "USD",
                          "value": "100.00"
                        }
                      }
                    ],
                    "payment_source": {
                      "paypal": {
                        "email_address": "customer@example.com",
                        "experience_context": {
                          "payment_method_preference": "IMMEDIATE_PAYMENT_REQUIRED",
                          "brand_name": "EXAMPLE INC",
                          "locale": "en-US",
                          "landing_page": "LOGIN",
                          "user_action": "PAY_NOW",
                          "return_url": "https://example.com/returnUrl",
                          "cancel_url": "https://example.com/cancelUrl",
                          "app_switch_context": {
                            "native_app": {
                              "return_app_url": "https://example.com/merchant_app/return",
                              "cancel_app_url": "https://example.com/merchant_app/cancel",
                              "os_type": "IOS",
                              "os_version": "17.3.1"
                            }
                          }
                        }
                      }
                    }
                  }
                },
                "samples_orders_create_orders_create_paypal_wallet_app_switch_android_low_ram_device_blocked": {
                  "summary": "Create and Authorize an order with PayPal Wallet where App Switch is Ineligible on a Low RAM Android Device",
                  "description": "Creates a new order with PayPal Wallet App Switch on a low RAM Android device (Samsung Galaxy A16 5G, SM-A166U, 4 GB total RAM). The merchant passes device metadata in device_info within app_switch_context. XOOS evaluates the device against the Elmo RAM threshold (default 400 MB) and model blocklist (SM-A166 prefix). The device fails both checks — available RAM is below the threshold and the model prefix is on the blocklist — so app_switch_eligibility is returned as false. The merchant must fall back to browser-based checkout using the returned payer-action URL.",
                  "value": {
                    "intent": "AUTHORIZE",
                    "purchase_units": [
                      {
                        "reference_id": "d9f80740-38f0-11e8-b467-0ed5f89f718b",
                        "amount": {
                          "currency_code": "USD",
                          "value": "100.00"
                        }
                      }
                    ],
                    "payment_source": {
                      "paypal": {
                        "email_address": "customer@example.com",
                        "experience_context": {
                          "payment_method_preference": "IMMEDIATE_PAYMENT_REQUIRED",
                          "brand_name": "EXAMPLE INC",
                          "locale": "en-US",
                          "landing_page": "LOGIN",
                          "user_action": "PAY_NOW",
                          "return_url": "https://example.com/returnUrl",
                          "cancel_url": "https://example.com/cancelUrl",
                          "app_switch_context": {
                            "native_app": {
                              "return_app_url": "https://example.com/merchant_app/return",
                              "cancel_app_url": "https://example.com/merchant_app/cancel",
                              "os_type": "ANDROID",
                              "os_version": "14"
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "A successful response to an idempotent request returns the HTTP `200 OK` status code with a JSON response body that shows order details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/order"
                },
                "examples": {
                  "samples_orders_create_samples_orders_create_00_orders_create": {
                    "summary": "Create Order - PayPal Wallet as Payment Source, Resulting in PAYER_ACTION_REQUIRED Response",
                    "description": "Creates a new order. API caller receives payer-action link.",
                    "value": {
                      "id": "5O190127TN364715T",
                      "status": "PAYER_ACTION_REQUIRED",
                      "payment_source": {
                        "paypal": {}
                      },
                      "links": [
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/5O190127TN364715T",
                          "rel": "self",
                          "method": "GET"
                        },
                        {
                          "href": "https://www.paypal.com/checkoutnow?token=5O190127TN364715T",
                          "rel": "payer-action",
                          "method": "GET"
                        }
                      ]
                    }
                  },
                  "samples_orders_create_orders_create_authorize_paypal_wallet_app_switch_with_return_cancel_app_url": {
                    "summary": "Create and Authorize an order with PayPal Wallet and App Switch with return, cancel and fallback app URLs",
                    "description": "Creates a new order and authorizes the payment using PayPal wallet with App Switch. Merchant provides separate return_app_url and cancel_app_url for native app redirection, which PayPal uses as-is without appending /success or /cancel.",
                    "value": {
                      "id": "5O190127TN364715T",
                      "status": "PAYER_ACTION_REQUIRED",
                      "links": [
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/5O190127TN364715T",
                          "rel": "self",
                          "method": "GET"
                        },
                        {
                          "href": "https://www.paypal.com/app-switch-checkout?token=5O190127TN364715T",
                          "rel": "payer-action",
                          "method": "GET"
                        }
                      ]
                    }
                  },
                  "samples_orders_create_orders_create_paypal_wallet_app_switch_android_low_ram_device_blocked": {
                    "summary": "Create and Authorize an order with PayPal Wallet where App Switch is Ineligible on a Low RAM Android Device",
                    "description": "Creates a new order with PayPal Wallet App Switch on a low RAM Android device (Samsung Galaxy A16 5G, SM-A166U, 4 GB total RAM). The merchant passes device metadata in device_info within app_switch_context. XOOS evaluates the device against the Elmo RAM threshold (default 400 MB) and model blocklist (SM-A166 prefix). The device fails both checks — available RAM is below the threshold and the model prefix is on the blocklist — so app_switch_eligibility is returned as false. The merchant must fall back to browser-based checkout using the returned payer-action URL.",
                    "value": {
                      "id": "5O190127TN364715T",
                      "status": "PAYER_ACTION_REQUIRED",
                      "links": [
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/5O190127TN364715T",
                          "rel": "self",
                          "method": "GET"
                        },
                        {
                          "href": "https://www.paypal.com/checkoutnow?token=5O190127TN364715T",
                          "rel": "payer-action",
                          "method": "GET"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "201": {
            "description": "A successful request returns the HTTP `201 Created` status code and a JSON response body that includes by default a minimal response with the ID, status, and HATEOAS links. If you require the complete order resource representation, you must pass the <a href=\"https://developer.paypal.com/docs/api/orders/v2/#orders-create-header-parameters\"><code>Prefer: return=representation</code> request header</a>. This header value is not the default.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/order"
                },
                "examples": {
                  "samples_orders_create_samples_orders_create_authorize_single_step_paypal_with_vault_id_and_stored_credentials_usage_pattern": {
                    "summary": "Create and authorize an order for a PayPal wallet vaulted account holder passing a usage pattern indicator using stored credentials (Single Shot).",
                    "description": "Creates an order and authorizes payment with a PayPal wallet vault id as the payment source and a usage pattern (billing indicator) RECURRING_PREPAID passed using stored credentials.",
                    "value": {
                      "id": "8K832279M55989614",
                      "intent": "AUTHORIZE",
                      "status": "COMPLETED",
                      "payment_source": {
                        "paypal": {
                          "email_address": "buyer@paypal.com",
                          "account_id": "XQHSN372NGSP2",
                          "account_status": "UNVERIFIED",
                          "name": {
                            "given_name": "Tom",
                            "surname": "Business"
                          },
                          "phone_number": {
                            "national_number": "8127081430"
                          },
                          "address": {
                            "country_code": "US"
                          },
                          "stored_credential": {
                            "payment_initiator": "MERCHANT",
                            "usage": "SUBSEQUENT",
                            "usage_pattern": "RECURRING_PREPAID"
                          }
                        }
                      },
                      "purchase_units": [
                        {
                          "reference_id": "default",
                          "amount": {
                            "currency_code": "USD",
                            "value": "100.00"
                          },
                          "payee": {
                            "email_address": "seller@paypal.com",
                            "merchant_id": "Q7C9N6S4YRQXG"
                          },
                          "shipping": {
                            "name": {
                              "full_name": "Tom Business"
                            },
                            "address": {
                              "address_line_1": "123 Fake St.",
                              "admin_area_2": "Baton Rouge",
                              "admin_area_1": "LA",
                              "postal_code": "70802",
                              "country_code": "US"
                            }
                          },
                          "payments": {
                            "authorizations": [
                              {
                                "status": "CREATED",
                                "id": "7X550106NA4440028",
                                "amount": {
                                  "currency_code": "USD",
                                  "value": "100.00"
                                },
                                "seller_protection": {
                                  "status": "ELIGIBLE",
                                  "dispute_categories": [
                                    "UNAUTHORIZED_TRANSACTION"
                                  ]
                                },
                                "expiration_time": "2024-06-05T18:46:54Z",
                                "links": [
                                  {
                                    "href": "https://api-m.paypal.com/v2/payments/authorizations/7X550106NA4440028",
                                    "rel": "self",
                                    "method": "GET"
                                  },
                                  {
                                    "href": "https://api-m.paypal.com/v2/payments/authorizations/7X550106NA4440028/capture",
                                    "rel": "capture",
                                    "method": "POST"
                                  },
                                  {
                                    "href": "https://api-m.paypal.com/v2/payments/authorizations/7X550106NA4440028/void",
                                    "rel": "void",
                                    "method": "POST"
                                  },
                                  {
                                    "href": "https://api-m.paypal.com/v2/checkout/orders/8K832279M55989614",
                                    "rel": "up",
                                    "method": "GET"
                                  }
                                ],
                                "create_time": "2024-05-07T18:46:54Z",
                                "update_time": "2024-05-07T18:46:54Z"
                              }
                            ]
                          }
                        }
                      ],
                      "payer": {
                        "name": {
                          "given_name": "Tom",
                          "surname": "Business"
                        },
                        "email_address": "buyer@paypal.com",
                        "payer_id": "XQHSN372NGSP2",
                        "phone": {
                          "phone_number": {
                            "national_number": "8127081430"
                          }
                        },
                        "address": {
                          "country_code": "US"
                        }
                      },
                      "create_time": "2024-05-07T18:46:15Z",
                      "update_time": "2024-05-07T18:46:54Z",
                      "links": [
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/8K832279M55989614",
                          "rel": "self",
                          "method": "GET"
                        }
                      ]
                    }
                  },
                  "samples_orders_create_samples_orders_create_orders_with_shipping_type_pickup_in_store": {
                    "summary": "Create Order - Buy Online Pickup In Store Shipping Type",
                    "description": "Creates an order with minimal parameters and contains the Buy Online Pickup in Store-related fields.",
                    "value": {
                      "id": "4SP74185RW2405200",
                      "intent": "AUTHORIZE",
                      "purchase_units": [
                        {
                          "reference_id": "PUHF",
                          "amount": {
                            "currency_code": "USD",
                            "value": "50.00"
                          },
                          "payee": {
                            "email_address": "merchant@example.com"
                          },
                          "shipping": {
                            "address": {
                              "address_line_1": "123 Townsend St",
                              "address_line_2": "Floor 6",
                              "admin_area_2": "San Francisco",
                              "admin_area_1": "CA",
                              "postal_code": "94107",
                              "country_code": "US"
                            },
                            "type": "PICKUP_IN_STORE"
                          }
                        }
                      ],
                      "links": [
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/4SP74185RW2405200",
                          "rel": "self",
                          "method": "GET"
                        },
                        {
                          "href": "https://www.paypal.com/checkoutnow?token=4SP74185RW2405200",
                          "rel": "approve",
                          "method": "GET"
                        },
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/4SP74185RW2405200",
                          "rel": "edit",
                          "method": "PATCH"
                        },
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/4SP74185RW2405200/authorize",
                          "rel": "authorize",
                          "method": "POST"
                        }
                      ],
                      "status": "CREATED"
                    }
                  },
                  "samples_orders_create_samples_orders_create_simple": {
                    "summary": "Create Order - Minimal Request and Response",
                    "description": "Creates an order with only required parameters. By default, uses the minimal representation.",
                    "value": {
                      "id": "5O190127TN364715T",
                      "status": "CREATED",
                      "links": [
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/5O190127TN364715T",
                          "rel": "self",
                          "method": "GET"
                        },
                        {
                          "href": "https://www.paypal.com/checkoutnow?token=5O190127TN364715T",
                          "rel": "approve",
                          "method": "GET"
                        },
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/5O190127TN364715T",
                          "rel": "edit",
                          "method": "PATCH"
                        },
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/5O190127TN364715T/capture",
                          "rel": "capture",
                          "method": "POST"
                        }
                      ]
                    }
                  },
                  "samples_orders_create_create_orders_with_venmo_app_switch_pickup_in_store": {
                    "summary": "Create Order - Buy Online Pickup In Store Shipping Type",
                    "description": "Creates an order with venmo payment source and contains the Buy Online Pickup in Store-related fields.",
                    "value": {
                      "id": "4SP74185RW2405200",
                      "intent": "AUTHORIZE",
                      "purchase_units": [
                        {
                          "reference_id": "PUHF",
                          "amount": {
                            "currency_code": "USD",
                            "value": "50.00"
                          },
                          "payee": {
                            "email_address": "merchant@example.com"
                          },
                          "shipping": {
                            "address": {
                              "address_line_1": "123 Townsend St",
                              "address_line_2": "Floor 6",
                              "admin_area_2": "San Francisco",
                              "admin_area_1": "CA",
                              "postal_code": "94107",
                              "country_code": "US"
                            },
                            "type": "PICKUP_IN_STORE"
                          }
                        }
                      ],
                      "links": [
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/4SP74185RW2405200",
                          "rel": "self",
                          "method": "GET"
                        },
                        {
                          "href": "https://www.paypal.com/checkoutnow?token=4SP74185RW2405200",
                          "rel": "approve",
                          "method": "GET"
                        },
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/4SP74185RW2405200",
                          "rel": "edit",
                          "method": "PATCH"
                        },
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/4SP74185RW2405200/authorize",
                          "rel": "authorize",
                          "method": "POST"
                        }
                      ],
                      "status": "CREATED"
                    }
                  }
                }
              }
            }
          },
          "202": {
            "description": "The request has been accepted for processing, but the processing has not been completed yet. The server returns the HTTP `202 Accepted` status code to indicate that the request is valid and will be handled asynchronously.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/order"
                }
              }
            }
          },
          "400": {
            "description": "Request is not well-formed, syntactically incorrect, or violates schema.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/error"
                },
                "examples": {
                  "error_samples_orders_create_error_samples_orders_create_400_bad_request": {
                    "summary": "Create Order - 400 Bad Request Error - Purchase Unit is Empty",
                    "description": "This code sample attempts to create an order with empty purchase units. The request fails.",
                    "value": {
                      "name": "INVALID_REQUEST",
                      "message": "Request is not well-formed, syntactically incorrect, or violates schema.",
                      "debug_id": "10398537340c8",
                      "details": [
                        {
                          "field": "/purchase_units",
                          "value": "[]",
                          "location": "body",
                          "issue": "INVALID_ARRAY_MIN_ITEMS",
                          "description": "The number of items in an array parameter is too small."
                        }
                      ],
                      "links": [
                        {
                          "href": "https://developer.paypal.com/api/orders/v2/#error-INVALID_ARRAY_MIN_ITEMS",
                          "rel": "information_link"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/401_error_response"
          },
          "403": {
            "$ref": "#/components/responses/403_error_response"
          },
          "422": {
            "description": "The requested action could not be performed, semantically incorrect, or failed business validation.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/error"
                },
                "examples": {
                  "error_samples_orders_create_error_samples_orders_create_422_unprocessable_entity_missing_pickup_address": {
                    "summary": "Create Order - 422 Unprocessable Entity Error - Missing Pickup Address",
                    "description": "This code sample attempts to create an order but the shipping address is required and `shipping.type` is set to PICKUP_FROM_PERSON ",
                    "value": {
                      "name": "UNPROCESSABLE_ENTITY",
                      "details": [
                        {
                          "field": "/purchase_units/@reference_id=='PUHF'/shipping/address",
                          "issue": "MISSING_SHIPPING_ADDRESS",
                          "description": "The shipping address is required when `shipping_preference=SET_PROVIDED_ADDRESS`."
                        }
                      ],
                      "message": "The requested action could not be performed, semantically incorrect, or failed business validation.",
                      "debug_id": "f200264a4e02a",
                      "links": [
                        {
                          "href": "https://developer.paypal.com/api/rest/reference/orders/v2/errors/#MISSING_SHIPPING_ADDRESS",
                          "rel": "information_link",
                          "method": "GET"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "500": {
            "$ref": "#/components/responses/500_error_response"
          },
          "default": {
            "$ref": "#/components/responses/default_response"
          }
        },
        "x-exampleFlows": [
          {
            "title": "Create Order - PayPal Wallet as Payment Source, Resulting in PAYER_ACTION_REQUIRED Response",
            "description": "Creates a new order. API caller receives payer-action link.",
            "parameter_examples": [
              "parameters/@name=='PayPal-Request-Id'/examples/request_id",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_create_samples_orders_create_00_orders_create",
            "response_example": "responses/200/content/application~1json/examples/samples_orders_create_samples_orders_create_00_orders_create"
          },
          {
            "title": "Create and authorize an order for a PayPal wallet vaulted account holder passing a usage pattern indicator using stored credentials (Single Shot).",
            "description": "Creates an order and authorizes payment with a PayPal wallet vault id as the payment source and a usage pattern (billing indicator) RECURRING_PREPAID passed using stored credentials.",
            "parameter_examples": [
              "parameters/@name=='PayPal-Request-Id'/examples/request_id",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_create_samples_orders_create_authorize_single_step_paypal_with_vault_id_and_stored_credentials_usage_pattern",
            "response_example": "responses/201/content/application~1json/examples/samples_orders_create_samples_orders_create_authorize_single_step_paypal_with_vault_id_and_stored_credentials_usage_pattern"
          },
          {
            "title": "Create Order - Minimal Request and Response",
            "description": "Creates an order with only required parameters. By default, uses the minimal representation.",
            "parameter_examples": [
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_create_samples_orders_create_simple",
            "response_example": "responses/201/content/application~1json/examples/samples_orders_create_samples_orders_create_simple"
          },
          {
            "title": "Create Order - Buy Online Pickup In Store Shipping Type",
            "description": "Creates an order with minimal parameters and contains the Buy Online Pickup in Store-related fields.",
            "parameter_examples": [
              "parameters/@name=='Authorization'/examples/bearer",
              "parameters/@name=='Prefer'/examples/samples_orders_create_samples_orders_create_orders_with_shipping_type_pickup_in_store"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_create_samples_orders_create_orders_with_shipping_type_pickup_in_store",
            "response_example": "responses/201/content/application~1json/examples/samples_orders_create_samples_orders_create_orders_with_shipping_type_pickup_in_store"
          },
          {
            "title": "Create Order - 400 Bad Request Error - Purchase Unit is Empty",
            "description": "This code sample attempts to create an order with empty purchase units. The request fails.",
            "parameter_examples": [
              "parameters/@name=='Authorization'/examples/bearer",
              "parameters/@name=='Prefer'/examples/samples_orders_create_samples_orders_create_order_mixed_cart_with_shipping_options_bwp_unknown_status"
            ],
            "response_example": "responses/400/content/application~1json/examples/error_samples_orders_create_error_samples_orders_create_400_bad_request"
          },
          {
            "title": "Create Order - 422 Unprocessable Entity Error - Missing Pickup Address",
            "description": "This code sample attempts to create an order but the shipping address is required and `shipping.type` is set to PICKUP_FROM_PERSON ",
            "parameter_examples": [
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/error_samples_orders_create_error_samples_orders_create_422_unprocessable_entity_missing_pickup_address",
            "response_example": "responses/422/content/application~1json/examples/error_samples_orders_create_error_samples_orders_create_422_unprocessable_entity_missing_pickup_address"
          },
          {
            "title": "Create Order - Buy Online Pickup In Store Shipping Type",
            "description": "Creates an order with venmo payment source and contains the Buy Online Pickup in Store-related fields.",
            "parameter_examples": [
              "parameters/@name=='Prefer'/examples/samples_orders_create_create_orders_with_venmo_app_switch_pickup_in_store",
              "parameters/@name=='PayPal-Request-Id'/examples/request_id",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_create_create_orders_with_venmo_app_switch_pickup_in_store",
            "response_example": "responses/201/content/application~1json/examples/samples_orders_create_create_orders_with_venmo_app_switch_pickup_in_store"
          },
          {
            "title": "Create and Authorize an order with PayPal Wallet and App Switch with return, cancel and fallback app URLs",
            "description": "Creates a new order and authorizes the payment using PayPal wallet with App Switch. Merchant provides separate return_app_url and cancel_app_url for native app redirection, which PayPal uses as-is without appending /success or /cancel.",
            "parameter_examples": [
              "parameters/@name=='PayPal-Request-Id'/examples/request_id",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_create_orders_create_authorize_paypal_wallet_app_switch_with_return_cancel_app_url",
            "response_example": "responses/200/content/application~1json/examples/samples_orders_create_orders_create_authorize_paypal_wallet_app_switch_with_return_cancel_app_url"
          },
          {
            "title": "Create and Authorize an order with PayPal Wallet where App Switch is Ineligible on a Low RAM Android Device",
            "description": "Creates a new order with PayPal Wallet App Switch on a low RAM Android device (Samsung Galaxy A16 5G, SM-A166U, 4 GB total RAM). The merchant passes device metadata in device_info within app_switch_context. XOOS evaluates the device against the Elmo RAM threshold (default 400 MB) and model blocklist (SM-A166 prefix). The device fails both checks — available RAM is below the threshold and the model prefix is on the blocklist — so app_switch_eligibility is returned as false. The merchant must fall back to browser-based checkout using the returned payer-action URL.",
            "parameter_examples": [
              "parameters/@name=='PayPal-Request-Id'/examples/request_id",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_create_orders_create_paypal_wallet_app_switch_android_low_ram_device_blocked",
            "response_example": "responses/200/content/application~1json/examples/samples_orders_create_orders_create_paypal_wallet_app_switch_android_low_ram_device_blocked"
          }
        ]
      }
    },
    "/v2/checkout/orders/{id}": {
      "get": {
        "operationId": "orders.get",
        "summary": "Show order details",
        "description": "Shows details for an order, by ID.<blockquote><strong>Note:</strong> For error handling and troubleshooting, see <a href=\"https://developer.paypal.com/api/rest/reference/orders/v2/errors/#get-order\">Orders v2 errors</a>.</blockquote>",
        "tags": [
          "orders"
        ],
        "security": [
          {
            "Oauth2": [
              "https://uri.paypal.com/services/payments/payment",
              "https://uri.paypal.com/services/payments/orders/deprecating-jssdk-migration-for-limited-merchants"
            ]
          }
        ],
        "parameters": [
          {
            "name": "id",
            "description": "The ID of the order for which to show details.",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "minLength": 1,
              "maxLength": 36,
              "pattern": "^[A-Z0-9]+$"
            },
            "examples": {
              "samples_orders_get_00_orders_get": {
                "summary": "Get Order - Show Order Details After Customer Approval",
                "description": "Shows order details immediately after customer approval.",
                "value": "5O190127TN364715T"
              }
            }
          },
          {
            "$ref": "#/components/parameters/authorization"
          },
          {
            "$ref": "#/components/parameters/paypal_auth_assertion"
          },
          {
            "name": "fields",
            "description": "A comma-separated list of fields that should be returned for the order. Valid filter field is `payment_source`.",
            "in": "query",
            "required": false,
            "schema": {
              "type": "string",
              "minLength": 0,
              "maxLength": 2147483647,
              "pattern": "^[a-z_]*$"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "A successful request returns the HTTP `200 OK` status code and a JSON response body that shows order details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/order"
                },
                "examples": {
                  "samples_orders_get_00_orders_get": {
                    "summary": "Get Order - Show Order Details After Customer Approval",
                    "description": "Shows order details immediately after customer approval.",
                    "value": {
                      "id": "5O190127TN364715T",
                      "status": "APPROVED",
                      "intent": "CAPTURE",
                      "payment_source": {
                        "paypal": {
                          "name": {
                            "given_name": "John",
                            "surname": "Doe"
                          },
                          "email_address": "customer@example.com",
                          "account_id": "QYR5Z8XDVJNXQ"
                        }
                      },
                      "purchase_units": [
                        {
                          "reference_id": "d9f80740-38f0-11e8-b467-0ed5f89f718b",
                          "amount": {
                            "currency_code": "USD",
                            "value": "100.00"
                          }
                        }
                      ],
                      "payer": {
                        "name": {
                          "given_name": "John",
                          "surname": "Doe"
                        },
                        "email_address": "customer@example.com",
                        "payer_id": "QYR5Z8XDVJNXQ"
                      },
                      "create_time": "2018-04-01T21:18:49Z",
                      "links": [
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/5O190127TN364715T",
                          "rel": "self",
                          "method": "GET"
                        },
                        {
                          "href": "https://www.paypal.com/checkoutnow?token=5O190127TN364715T",
                          "rel": "approve",
                          "method": "GET"
                        },
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/5O190127TN364715T",
                          "rel": "edit",
                          "method": "PATCH"
                        },
                        {
                          "href": "https://api-m.paypal.com/v2/checkout/orders/5O190127TN364715T/capture",
                          "rel": "capture",
                          "method": "POST"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/401_error_response"
          },
          "403": {
            "$ref": "#/components/responses/403_error_response"
          },
          "404": {
            "$ref": "#/components/responses/404_error_response"
          },
          "500": {
            "$ref": "#/components/responses/500_error_response"
          },
          "default": {
            "$ref": "#/components/responses/default_response"
          }
        },
        "x-exampleFlows": [
          {
            "title": "Get Order - Show Order Details After Customer Approval",
            "description": "Shows order details immediately after customer approval.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_get_00_orders_get",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "response_example": "responses/200/content/application~1json/examples/samples_orders_get_00_orders_get"
          },
          {
            "title": "Get Order - 404 Not Found Error - Order Not Found",
            "description": "This code sample attempts to show details for an order, by ID, but the request fails because the order is not found.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_get_00_orders_get"
            ],
            "response_example": "responses/404/content/application~1json/examples/generic"
          }
        ]
      },
      "patch": {
        "operationId": "orders.patch",
        "summary": "Update order",
        "description": "Updates an order with a `CREATED` or `APPROVED` status. You cannot update an order with the `COMPLETED` status.<br/><br/>To make an update, you must provide a `reference_id`. If you omit this value with an order that contains only one purchase unit, PayPal sets the value to `default` which enables you to use the path: <code>\\\"/purchase_units/@reference_id=='default'/{attribute-or-object}\\\"</code>. Merchants and partners can add Level 2 and 3 data to payments to reduce risk and payment processing costs. For more information about processing payments, see <a href=\"https://developer.paypal.com/docs/checkout/advanced/processing/\">checkout</a> or <a href=\"https://developer.paypal.com/docs/multiparty/checkout/advanced/processing/\">multiparty checkout</a>.<blockquote><strong>Note:</strong> For error handling and troubleshooting, see <a href=\"https://developer.paypal.com/api/rest/reference/orders/v2/errors/#patch-order\">Orders v2 errors</a>.</blockquote>Patchable attributes or objects:<br/><br/><table><thead><th>Attribute</th><th>Op</th><th>Notes</th></thead><tbody><tr><td><code>intent</code></td><td>replace</td><td></td></tr><tr><td><code>payer</code></td><td>replace, add</td><td>Using replace op for <code>payer</code> will replace the whole <code>payer</code> object with the value sent in request.</td></tr><tr><td><code>purchase_units</code></td><td>replace, add</td><td></td></tr><tr><td><code>purchase_units[].custom_id</code></td><td>replace, add, remove</td><td></td></tr><tr><td><code>purchase_units[].description</code></td><td>replace, add, remove</td><td></td></tr><tr><td><code>purchase_units[].payee.email</code></td><td>replace</td><td></td></tr><tr><td><code>purchase_units[].shipping.name</code></td><td>replace, add</td><td></td></tr><tr><td><code>purchase_units[].shipping.email_address</code></td><td>replace, add</td><td></td></tr><tr><td><code>purchase_units[].shipping.phone_number</code></td><td>replace, add</td><td></td></tr><tr><td><code>purchase_units[].shipping.options</code></td><td>replace, add</td><td></td></tr><tr><td><code>purchase_units[].shipping.address</code></td><td>replace, add</td><td></td></tr><tr><td><code>purchase_units[].shipping.type</code></td><td>replace, add</td><td></td></tr><tr><td><code>purchase_units[].soft_descriptor</code></td><td>replace, remove</td><td></td></tr><tr><td><code>purchase_units[].amount</code></td><td>replace</td><td></td></tr><tr><td><code>purchase_units[].items</code></td><td>replace, add, remove</td><td></td></tr><tr><td><code>purchase_units[].invoice_id</code></td><td>replace, add, remove</td><td></td></tr><tr><td><code>purchase_units[].payment_instruction</code></td><td>replace</td><td></td></tr><tr><td><code>purchase_units[].payment_instruction.disbursement_mode</code></td><td>replace</td><td>By default, <code>disbursement_mode</code> is <code>INSTANT</code>.</td></tr><tr><td><code>purchase_units[].payment_instruction.payee_receivable_fx_rate_id</code></td><td>replace, add, remove</td><td></td></tr><tr><td><code>purchase_units[].payment_instruction.platform_fees</code></td><td>replace, add, remove</td><td></td></tr><tr><td><code>purchase_units[].supplementary_data.airline</code></td><td>replace, add, remove</td><td></td></tr><tr><td><code>purchase_units[].supplementary_data.card</code></td><td>replace, add, remove</td><td></td></tr><tr><td><code>application_context.client_configuration</code></td><td>replace, add</td><td></td></tr></tbody></table>",
        "tags": [
          "orders"
        ],
        "security": [
          {
            "Oauth2": [
              "https://uri.paypal.com/services/payments/payment",
              "https://uri.paypal.com/services/payments/orders/deprecating-jssdk-migration-for-limited-merchants"
            ]
          }
        ],
        "parameters": [
          {
            "name": "id",
            "description": "The ID of the order to update.",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "minLength": 1,
              "maxLength": 36,
              "pattern": "^[A-Z0-9]+$"
            },
            "examples": {
              "samples_orders_patch_00_orders_patch": {
                "summary": "Patch Order - Add Shipping Address",
                "description": "Updates an order to add shipping address to purchase unit.",
                "value": "5O190127TN364715T"
              },
              "samples_orders_patch_add_items_and_replace_amount": {
                "summary": "Patch Order - Add Items and Replace Amount",
                "description": "Updates an order to add items to and replace the amount within a purchase unit. The amount breakdown with an item total is added to reflect the newly added items. Whenever the quantity or price of items is modified in an order with a PATCH, the purchase_units.amount must also be updated.",
                "value": "5O190127TN364715T"
              },
              "samples_orders_patch_replace_amount": {
                "summary": "Patch Order - Replace Amount",
                "description": "Updates an order to revise the amount, adding the cost of shipping, to a purchase unit.",
                "value": "5O190127TN364715T"
              },
              "error_samples_orders_patch_422_payer_patch_not_allowed": {
                "summary": "Patch Order - 422 Unprocessable Entity Error - Payer Patch Not Allowed",
                "description": "This code sample attempts to update an order with a payer object. The request fails since buyer has already approved.",
                "value": "5O190127TN364715T"
              }
            }
          },
          {
            "$ref": "#/components/parameters/authorization"
          },
          {
            "$ref": "#/components/parameters/paypal_auth_assertion"
          }
        ],
        "requestBody": {
          "required": false,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/patch_request"
              },
              "examples": {
                "samples_orders_patch_00_orders_patch": {
                  "summary": "Patch Order - Add Shipping Address",
                  "description": "Updates an order to add shipping address to purchase unit.",
                  "value": [
                    {
                      "op": "replace",
                      "path": "/purchase_units/@reference_id=='PUHF'/shipping/address",
                      "value": {
                        "address_line_1": "2211 N First Street",
                        "address_line_2": "Building 17",
                        "admin_area_2": "San Jose",
                        "admin_area_1": "CA",
                        "postal_code": "95131",
                        "country_code": "US"
                      }
                    }
                  ]
                },
                "samples_orders_patch_add_items_and_replace_amount": {
                  "summary": "Patch Order - Add Items and Replace Amount",
                  "description": "Updates an order to add items to and replace the amount within a purchase unit. The amount breakdown with an item total is added to reflect the newly added items. Whenever the quantity or price of items is modified in an order with a PATCH, the purchase_units.amount must also be updated.",
                  "value": [
                    {
                      "op": "add",
                      "path": "/purchase_units/@reference_id=='PUHF'/items",
                      "value": [
                        {
                          "name": "T-Shirt",
                          "description": "Green XL",
                          "sku": "sku01",
                          "unit_amount": {
                            "currency_code": "USD",
                            "value": "90.00"
                          },
                          "tax": {
                            "currency_code": "USD",
                            "value": "10.00"
                          },
                          "quantity": "1",
                          "category": "PHYSICAL_GOODS"
                        },
                        {
                          "name": "Shoes",
                          "description": "Running, Size 10.5",
                          "sku": "sku02",
                          "unit_amount": {
                            "currency_code": "USD",
                            "value": "45.00"
                          },
                          "tax": {
                            "currency_code": "USD",
                            "value": "5.00"
                          },
                          "quantity": "2",
                          "category": "PHYSICAL_GOODS"
                        }
                      ]
                    },
                    {
                      "op": "replace",
                      "path": "/purchase_units/@reference_id=='PUHF'/amount",
                      "value": {
                        "currency_code": "USD",
                        "value": "205.00",
                        "breakdown": {
                          "item_total": {
                            "currency_code": "USD",
                            "value": "180.00"
                          },
                          "shipping": {
                            "currency_code": "USD",
                            "value": "5.00"
                          },
                          "handling": {
                            "currency_code": "USD",
                            "value": "0.00"
                          },
                          "tax_total": {
                            "currency_code": "USD",
                            "value": "20.00"
                          },
                          "shipping_discount": {
                            "currency_code": "USD",
                            "value": "0.00"
                          }
                        }
                      }
                    }
                  ]
                },
                "samples_orders_patch_replace_amount": {
                  "summary": "Patch Order - Replace Amount",
                  "description": "Updates an order to revise the amount, adding the cost of shipping, to a purchase unit.",
                  "value": [
                    {
                      "op": "replace",
                      "path": "/purchase_units/@reference_id=='PUHF'/amount",
                      "value": {
                        "currency_code": "USD",
                        "value": "200.00",
                        "breakdown": {
                          "item_total": {
                            "currency_code": "USD",
                            "value": "180.00"
                          },
                          "shipping": {
                            "currency_code": "USD",
                            "value": "20.00"
                          }
                        }
                      }
                    }
                  ]
                },
                "error_samples_orders_patch_422_payer_patch_not_allowed": {
                  "summary": "Patch Order - 422 Unprocessable Entity Error - Payer Patch Not Allowed",
                  "description": "This code sample attempts to update an order with a payer object. The request fails since buyer has already approved.",
                  "value": [
                    {
                      "op": "add",
                      "path": "/payer",
                      "value": {
                        "name": {
                          "given_name": "TestFirst",
                          "surname": "TestLast"
                        },
                        "email_address": "payee@example.com",
                        "phone": {
                          "phone_number": {
                            "national_number": "19876543210"
                          }
                        },
                        "address": {
                          "address_line_1": "2211 North First Street",
                          "address_line_2": "Floor 6",
                          "admin_area_2": "San Jose",
                          "admin_area_1": "CA",
                          "postal_code": "95126",
                          "country_code": "US"
                        }
                      }
                    }
                  ]
                }
              }
            }
          }
        },
        "responses": {
          "204": {
            "$ref": "#/components/responses/204_response"
          },
          "400": {
            "description": "Request is not well-formed, syntactically incorrect, or violates schema.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/error"
                },
                "examples": {
                  "error_samples_orders_patch_400_invalid_shipping_address": {
                    "summary": "Patch Order - 400 Bad Request Error - Shipping Address Invalid",
                    "description": "This code sample attempts to update an the shipping address with an invalid value. The request fails.",
                    "value": {
                      "name": "INVALID_REQUEST",
                      "details": [
                        {
                          "field": "/purchase_units/@reference_id=='Reference ID 2'/shipping/address",
                          "value": "x",
                          "location": "body",
                          "issue": "INVALID_PARAMETER_SYNTAX",
                          "description": "The value of a field does not conform to the expected format."
                        }
                      ],
                      "message": "Request is not well-formed, syntactically incorrect, or violates schema.",
                      "debug_id": "f087ef02ffdb6",
                      "links": [
                        {
                          "href": "https://developer.paypal.com/api/orders/v2/#error-INVALID_PARAMETER_SYNTAX",
                          "rel": "information_link",
                          "method": "GET"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/401_error_response"
          },
          "403": {
            "$ref": "#/components/responses/403_error_response"
          },
          "404": {
            "$ref": "#/components/responses/404_error_response"
          },
          "422": {
            "description": "The requested action could not be performed, semantically incorrect, or failed business validation.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/error"
                },
                "examples": {
                  "error_samples_orders_patch_422_payer_patch_not_allowed": {
                    "summary": "Patch Order - 422 Unprocessable Entity Error - Payer Patch Not Allowed",
                    "description": "This code sample attempts to update an order with a payer object. The request fails since buyer has already approved.",
                    "value": {
                      "name": "UNPROCESSABLE_ENTITY",
                      "details": [
                        {
                          "field": "/payer",
                          "issue": "PAYER_PATCH_NOT_ALLOWED",
                          "description": "Payer path patch is not allowed after payer has approved the order.",
                          "location": "body"
                        }
                      ],
                      "message": "The requested action could not be performed, semantically incorrect, or failed business validation.",
                      "debug_id": "90957fca61718",
                      "links": [
                        {
                          "href": "https://developer.paypal.com/api/orders/v2/#error-PAYER_PATCH_NOT_ALLOWED",
                          "rel": "information_link",
                          "method": "GET"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "500": {
            "$ref": "#/components/responses/500_error_response"
          },
          "default": {
            "$ref": "#/components/responses/default_response"
          }
        },
        "x-exampleFlows": [
          {
            "title": "Patch Order - Add Shipping Address",
            "description": "Updates an order to add shipping address to purchase unit.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_patch_00_orders_patch",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_patch_00_orders_patch"
          },
          {
            "title": "Patch Order - Replace Amount",
            "description": "Updates an order to revise the amount, adding the cost of shipping, to a purchase unit.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_patch_replace_amount",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_patch_replace_amount"
          },
          {
            "title": "Patch Order - Add Items and Replace Amount",
            "description": "Updates an order to add items to and replace the amount within a purchase unit. The amount breakdown with an item total is added to reflect the newly added items. Whenever the quantity or price of items is modified in an order with a PATCH, the purchase_units.amount must also be updated.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_patch_add_items_and_replace_amount",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_patch_add_items_and_replace_amount"
          },
          {
            "title": "Patch Order - 400 Bad Request Error - Shipping Address Invalid",
            "description": "This code sample attempts to update an the shipping address with an invalid value. The request fails.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_patch_replace_amount_with_discount_breakdown",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "response_example": "responses/400/content/application~1json/examples/error_samples_orders_patch_400_invalid_shipping_address"
          },
          {
            "title": "Patch Order - 422 Unprocessable Entity Error - Payer Patch Not Allowed",
            "description": "This code sample attempts to update an order with a payer object. The request fails since buyer has already approved.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/error_samples_orders_patch_422_payer_patch_not_allowed",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/error_samples_orders_patch_422_payer_patch_not_allowed",
            "response_example": "responses/422/content/application~1json/examples/error_samples_orders_patch_422_payer_patch_not_allowed"
          }
        ]
      }
    },
    "/v2/checkout/orders/{id}/confirm-payment-source": {
      "post": {
        "operationId": "orders.confirm",
        "summary": "Confirm the Order",
        "description": "Payer confirms their intent to pay for the the Order with the given payment source.",
        "tags": [
          "orders"
        ],
        "security": [
          {
            "Oauth2": [
              "https://uri.paypal.com/services/payments/payment",
              "https://uri.paypal.com/services/payments/initiatepayment",
              "https://uri.paypal.com/services/payments/orders/client_sdk_orders_api"
            ]
          }
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/paypal_client_metadata_id"
          },
          {
            "name": "id",
            "description": "The ID of the order for which the payer confirms their intent to pay.",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "minLength": 1,
              "maxLength": 36,
              "pattern": "^[A-Z0-9]+$"
            },
            "examples": {
              "samples_orders_confirm_00_orders_confirm": {
                "summary": "Confirm Order - PayPal Wallet Resulting in Payer Action Required",
                "description": "The API Caller is adding or changing the PayPal wallet payment_source on an Order after the Order has been created. Orders status transitions to PAYER_ACTION_REQUIRED.",
                "value": "5O190127TN364715T"
              },
              "error_samples_orders_confirm_422_unprocessable_entity_paypal_wallet_vault_id_payment_source_mismatch": {
                "summary": "Confirm Order - 422 Unprocessable Entity Error -Using Card Vault ID for a PayPal Wallet Payment Source",
                "description": "Attempt to Confirm PayPal Wallet for an order with card vault id. The request fails with a MISMATCHED_VAULT_ID_TO_PAYMENT_SOURCE error.",
                "value": "5O190127TN364715T"
              }
            }
          },
          {
            "$ref": "#/components/parameters/authorization"
          },
          {
            "$ref": "#/components/parameters/paypal_auth_assertion"
          },
          {
            "name": "Prefer",
            "description": "The preferred server response upon successful completion of the request. Value is:<ul><li><code>return=minimal</code>. The server returns a minimal response to optimize communication between the API caller and the server. A minimal response includes the <code>id</code>, <code>status</code> and HATEOAS links.</li><li><code>return=representation</code>. The server returns a complete resource representation, including the current state of the resource.</li></ul>",
            "in": "header",
            "required": false,
            "schema": {
              "type": "string",
              "minLength": 1,
              "maxLength": 25,
              "pattern": "^[a-zA-Z=]*$",
              "default": "return=minimal"
            }
          }
        ],
        "requestBody": {
          "required": false,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/confirm_order_request"
              },
              "examples": {
                "samples_orders_confirm_00_orders_confirm": {
                  "summary": "Confirm Order - PayPal Wallet Resulting in Payer Action Required",
                  "description": "The API Caller is adding or changing the PayPal wallet payment_source on an Order after the Order has been created. Orders status transitions to PAYER_ACTION_REQUIRED.",
                  "value": {
                    "payment_source": {
                      "paypal": {
                        "name": {
                          "given_name": "John",
                          "surname": "Doe"
                        },
                        "email_address": "customer@example.com",
                        "experience_context": {
                          "payment_method_preference": "IMMEDIATE_PAYMENT_REQUIRED",
                          "brand_name": "EXAMPLE INC",
                          "locale": "en-US",
                          "landing_page": "LOGIN",
                          "shipping_preference": "SET_PROVIDED_ADDRESS",
                          "user_action": "PAY_NOW",
                          "return_url": "https://example.com/returnUrl",
                          "cancel_url": "https://example.com/cancelUrl"
                        }
                      }
                    }
                  }
                },
                "error_samples_orders_confirm_422_unprocessable_entity_paypal_wallet_vault_id_payment_source_mismatch": {
                  "summary": "Confirm Order - 422 Unprocessable Entity Error -Using Card Vault ID for a PayPal Wallet Payment Source",
                  "description": "Attempt to Confirm PayPal Wallet for an order with card vault id. The request fails with a MISMATCHED_VAULT_ID_TO_PAYMENT_SOURCE error.",
                  "value": {
                    "payment_source": {
                      "paypal": {
                        "vault_id": "8kk845"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "A successful request indicates that the payment source was added to the Order. A successful request returns the HTTP `200 OK` status code with a JSON response body that shows order details.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/order"
                },
                "examples": {
                  "samples_orders_confirm_00_orders_confirm": {
                    "summary": "Confirm Order - PayPal Wallet Resulting in Payer Action Required",
                    "description": "The API Caller is adding or changing the PayPal wallet payment_source on an Order after the Order has been created. Orders status transitions to PAYER_ACTION_REQUIRED.",
                    "value": {
                      "id": "5O190127TN364715T",
                      "status": "PAYER_ACTION_REQUIRED",
                      "payment_source": {
                        "paypal": {
                          "name": {
                            "given_name": "John",
                            "surname": "Doe"
                          },
                          "email_address": "customer@example.com"
                        }
                      },
                      "payer": {
                        "name": {
                          "given_name": "John",
                          "surname": "Doe"
                        },
                        "email_address": "customer@example.com"
                      },
                      "links": [
                        {
                          "href": "https://api.paypal.com/v2/checkout/orders/5O190127TN364715T",
                          "rel": "self",
                          "method": "GET"
                        },
                        {
                          "href": "https://www.paypal.com/checkoutnow?token=5O190127TN364715T",
                          "rel": "payer-action",
                          "method": "GET"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Request is not well-formed, syntactically incorrect, or violates schema.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/error"
                },
                "examples": {
                  "error_samples_orders_confirm_400_bad_request_missing_required_parameter": {
                    "summary": "Confirm Order - 400 Bad Request Error - Missing Required Parameter - Payment Source",
                    "description": "This code sample attempts to confirm an order, but the payment source is missing. The request fails.",
                    "value": {
                      "name": "INVALID_REQUEST",
                      "details": [
                        {
                          "field": "/payment_source",
                          "issue": "MISSING_REQUIRED_PARAMETER",
                          "description": "A required field or parameter is missing.",
                          "location": "body"
                        }
                      ],
                      "message": "Request is not well-formed, syntactically incorrect, or violates schema.",
                      "debug_id": "90957fca61718",
                      "links": [
                        {
                          "href": "https://developer.paypal.com/api/orders/v2/#error-MISSING_REQUIRED_PARAMETER",
                          "rel": "information_link",
                          "method": "GET"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "401": {
            "$ref": "#/components/responses/401_error_response"
          },
          "403": {
            "$ref": "#/components/responses/403_error_response"
          },
          "422": {
            "description": "The requested action could not be performed, semantically incorrect, or failed business validation.",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/error"
                },
                "examples": {
                  "error_samples_orders_confirm_422_unprocessable_entity_paypal_wallet_vault_id_payment_source_mismatch": {
                    "summary": "Confirm Order - 422 Unprocessable Entity Error -Using Card Vault ID for a PayPal Wallet Payment Source",
                    "description": "Attempt to Confirm PayPal Wallet for an order with card vault id. The request fails with a MISMATCHED_VAULT_ID_TO_PAYMENT_SOURCE error.",
                    "value": {
                      "name": "UNPROCESSABLE_ENTITY",
                      "details": [
                        {
                          "field": "/payment_source/paypal/vault_id",
                          "location": "body",
                          "issue": "MISMATCHED_VAULT_ID_TO_PAYMENT_SOURCE",
                          "description": "The vault_id does not match the payment_source provided. Please verify that the vault_id token used refers to the matching payment_source and try again. For example, a PayPal token cannot be passed in the vault_id field in the payment_source.card object."
                        }
                      ],
                      "message": "The requested action could not be performed, semantically incorrect, or failed business validation.",
                      "debug_id": "90957fca61718",
                      "links": [
                        {
                          "href": "https://developer.paypal.com/docs/api/orders/v2/#error-MISMATCHED_VAULT_ID_TO_PAYMENT_SOURCE",
                          "rel": "information_link",
                          "method": "GET"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "500": {
            "$ref": "#/components/responses/500_error_response"
          },
          "default": {
            "$ref": "#/components/responses/default_response"
          }
        },
        "x-exampleFlows": [
          {
            "title": "Confirm Order - PayPal Wallet Resulting in Payer Action Required",
            "description": "The API Caller is adding or changing the PayPal wallet payment_source on an Order after the Order has been created. Orders status transitions to PAYER_ACTION_REQUIRED.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_confirm_00_orders_confirm",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_confirm_00_orders_confirm",
            "response_example": "responses/200/content/application~1json/examples/samples_orders_confirm_00_orders_confirm"
          },
          {
            "title": "Confirm Order - 400 Bad Request Error - Missing Required Parameter - Payment Source",
            "description": "This code sample attempts to confirm an order, but the payment source is missing. The request fails.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_confirm_apm_payment_source_klarna",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "response_example": "responses/400/content/application~1json/examples/error_samples_orders_confirm_400_bad_request_missing_required_parameter"
          },
          {
            "title": "Confirm Order - 403 Forbidden Error -  Invalid PayPal Wallet Vault ID",
            "description": "This code sample attempts to confirm an order but the PayPal wallet vault ID was not found. The request fails.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_confirm_apm_payment_source_klarna",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_confirm_apm_payment_source_klarna",
            "response_example": "responses/403/content/application~1json/examples/generic"
          },
          {
            "title": "Confirm Order - 404 Not Found Error - Resource Not Found",
            "description": "This code sample attempts to confirm an order but the specified order is not found. The request fails.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_confirm_00_orders_confirm"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_confirm_00_orders_confirm"
          },
          {
            "title": "Confirm Order - 422 Unprocessable Entity Error -Using Card Vault ID for a PayPal Wallet Payment Source",
            "description": "Attempt to Confirm PayPal Wallet for an order with card vault id. The request fails with a MISMATCHED_VAULT_ID_TO_PAYMENT_SOURCE error.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/error_samples_orders_confirm_422_unprocessable_entity_paypal_wallet_vault_id_payment_source_mismatch",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/error_samples_orders_confirm_422_unprocessable_entity_paypal_wallet_vault_id_payment_source_mismatch",
            "response_example": "responses/422/content/application~1json/examples/error_samples_orders_confirm_422_unprocessable_entity_paypal_wallet_vault_id_payment_source_mismatch"
          },
          {
            "title": "Confirm Order - 500 Internal Server Error - A system error has occurred",
            "description": "This code sample attempts to confirm an order, but a system error occurred. The request fails. The same request body may be reused by the API Caller to retry.",
            "parameter_examples": [
              "parameters/@name=='id'/examples/samples_orders_confirm_apm_payment_source_klarna",
              "parameters/@name=='Authorization'/examples/bearer"
            ],
            "request_body_example": "requestBody/content/application~1json/examples/samples_orders_confirm_apm_payment_source_klarna",
            "response_example": "responses/500/content/application~1json/examples/generic"
          }
        ]
      }
    },
    "/v2/checkout/orders/{id}/authorize": {
      "post": {
        "operationId": "orders.authorize",
        "summary": "Authorize payment for order",
        "description": "Authorizes payment for an order. To successfully authorize payment for an order, the buyer must first approve the order or a valid payment_source must be provided in the request. A buyer can approve the order upon being redirected to the rel:approve URL that was returned in the HATEOAS links in the create order response.<blockquote><strong>Note:</strong> For error handling and troubleshooting, see <a href=\"https://developer.paypal.com/api/rest/reference/orders/v2/errors/#authorize-order\">Orders v2 errors</a>.</blockquote>",
        "tags": [
          "orders"
        ],
        "security": [
          {
            "Oauth2": [
              "https://uri.paypal.com/services/payments/payment",
              "https://uri.paypal.com/services/payments/orders/deprecating-jssdk-migration-for-limited-merchants"
            ]
          }
        ],
        "parameters": [
          {
            "$ref": "#/components/parameters/paypal_request_id"
          },
          {
            "name": "Prefer",
            "description": "The preferred server response upon successful completion of the request. Value is:<ul><li><code>return=minimal</code>. The server returns a minimal response to optimize communication between the API caller and the server. A minimal response includes the <code>id</code>, <code>status</code> and HATEOAS links.</li><li><code>return=representation</code>. The server returns a complete resource representation, including the current state of the resource.</li></ul>",
            "in": "header",
            "required": false,
            "schema": {
              "type": "string",
              "minLength": 1,
              "maxLength": 25,
              "pattern": "^[a-zA-Z=,-]*$",
              "default": "return=minimal"
            }
          },
          {
            "$ref": "#/components/parameters/paypal_client_metadata_id"
          },
          {
            "name": "id",
            "description": "The ID of the order for which to authorize.",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "minLength": 1,
              "maxLength": 36,
              "pattern": "^[A-Z0-9]+$"
            },
            "examples": {
              "samples_orders_authorize_00_orders_authorize": {
                "summary": "Authorize Order - PayPal Wallet as Payment Source",
                "description": "Authorize payment for an order after PayPal wallet approval. By default, uses the minimal representation.",
                "value": "5O190127TN364715T"
              },
              "error_samples_orders_authorize_422_payer_action_required_cib_psd2_sca_ba_in_sc": {
                "summary": "Authorize Order - 422 - Payer Action Required",
                "description": "This code sample attempts to authorize payment for an order that was created by the api caller and the payment could not be processed due to PSD2 SCA compliance requirement.",
                "value": "9SY02093A2309081P"
              },
              "error_samples_orders_authorize_422_unprocessable_entity_payment_denied": {
                "summary": "Authorize Order - 422 Unprocessable Entity Error - Payment Denied",
                "description": "This code sample attempts to authorize an order, but the payment is denied by PayPal. This can occur due to various reasons such as insufficient funds, expired card, incorrect payment information, or payment gateway issues.",
                "value": "5O190127TN364715T"
              },
              "samples_orders_authorize_idempotent": {
                "summary": "Authorize Order - Idempotent Response with PayPal Wallet",
                "description": "Authorizes payment for an order with the same idempotency key. By default, uses the minimal representation.",
                "value": "5O190127TN364715T"
              },
              "samples_orders_authorize_paypal_wallet_vault_id": {
                "summary": "Authorize Order - PayPal Wallet Vault ID",
                "description": "Authorizes payment for an order through a previously acquired vault id for a PayPal wallet. By default, uses the minimal representation.",
                "value": "5O190127TN364715T"
              }
            }
          },
          {
            "$ref": "#/components/parameters/authorization"
          },
          {
            "$ref": "#/components/parameters/paypal_auth_assertion"
          }
        ],
        "requestBody": {
          "required": false,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/order_authorize_request"
              },
              "examples": {
                "samples_orders_authorize_00_orders_authorize": {
                  "summary": "Authorize Order - PayPal Wallet as Payment Source",
                  "description": "Authorize payment for an order after PayPal wallet approval. By default, uses the minimal representation.",
                  "value": {}
                },
                "error_samples_orders_authorize_422_payer_action_required_cib_psd2_sca_ba_in_sc": {
                  "summary": "Authorize Order - 422 - Payer Action Required",
                  "description": "This code sample attempts to authorize payment for an order that was created by the api caller and the payment could not be processed due to PSD2 SCA compliance requirement.",
                  "value": {}
                },
                "error_samples_orders_authorize_422_unprocessable_entity_payment_denied": {
                  "summary": "Authorize Order - 422 Unprocessable Entity Error - Payment Denied",
                  "description": "This code sample attempts to authorize an order, but the payment is denied by PayPal. This can occur due to various reasons such as insufficient funds, expired card, incorrect payment information, or payment gateway issues.",
                  "value": {
                    "payment_source": {
                      "card": {
                        "vault_id": "8cg02452we902502k"
                      }
                    }
                  }
                },
                "samples_orders_authorize_idempotent": {
                  "summary": "Authorize Order - Idempotent Response with PayPal Wallet",
                  "description": "Authorizes payment for an order with the same idempotency key. By default, uses the minimal representation.",
                  "value": {}
                },
                "samples_orders_authorize_paypal_wallet_vault_id": {
                  "summary": "Authorize Order - PayPal Wallet Vault ID",
                  "description": "Authorizes payment for an order through a previously acquired vault id for a PayPal wallet. By default, uses the minimal representation.",
                  "value": {
                    "payment_source": {
                      "paypal": {
                        "vault_id": "nkq2y9g"
                      }
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "A successful response to an idempotent request returns the HTTP `200 OK` status code with a JSON response body that shows authorized payment details.",
            "content": {
              "application/json": {
[...]
